Angular Tooltip - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/tooltip/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import TooltipModule from smart-webcomponents-angular/tooltip: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { TooltipModule } from 'smart-webcomponents-angular/tooltip';

4 Root component (standalone)

Add TooltipModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { ButtonComponent } from 'smart-webcomponents-angular/button';
import { RadioButtonComponent } from 'smart-webcomponents-angular/radiobutton';
import { TooltipComponent } from 'smart-webcomponents-angular/tooltip';

import { ButtonModule } from 'smart-webcomponents-angular/button';

import { RadioButtonModule } from 'smart-webcomponents-angular/radiobutton';

import { TooltipModule } from 'smart-webcomponents-angular/tooltip';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ButtonModule, RadioButtonModule, TooltipModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('button', { read: ButtonComponent, static: false }) button!: ButtonComponent;
    @ViewChild('radiobutton', { read: RadioButtonComponent, static: false }) radiobutton!: RadioButtonComponent;
    @ViewChild('radiobutton2', { read: RadioButtonComponent, static: false }) radiobutton2!: RadioButtonComponent;
    @ViewChild('radiobutton3', { read: RadioButtonComponent, static: false }) radiobutton3!: RadioButtonComponent;
    @ViewChild('radiobutton4', { read: RadioButtonComponent, static: false }) radiobutton4!: RadioButtonComponent;
    @ViewChild('tooltip', { read: TooltipComponent, static: false }) tooltip!: TooltipComponent;


    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.

        const that = this,
            tooltip = that.tooltip;

        that.radiobutton.addEventListener('change', function ():void {
            tooltip.position = 'top';
        });

        that.radiobutton2.addEventListener('change', function ():void {
            tooltip.position = 'bottom';
        });

        that.radiobutton3.addEventListener('change', function ():void {
            tooltip.position = 'left';
        });

        that.radiobutton4.addEventListener('change', function ():void {
            tooltip.position = 'right';
        });
    }
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-tooltip as needed:

 <smart-button #button id="button">Button</smart-button>
<smart-tooltip #tooltip id="tooltip" [selector]="'button'" [arrow]="true">This is a tooltip for smartButton</smart-tooltip>
<div class="options">
     <h3>Tooltip Position:</h3>
    <smart-radio-button #radiobutton [checked]="true">Top</smart-radio-button>
    <br/>
    <smart-radio-button #radiobutton2>Bottom</smart-radio-button>
    <br/>
    <smart-radio-button #radiobutton3>Left</smart-radio-button>
    <br/>
    <smart-radio-button #radiobutton4>Right</smart-radio-button>
    <br/>
</div>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put TooltipModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put TooltipModule from smart-webcomponents-angular/tooltip on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { TooltipModule } from 'smart-webcomponents-angular/tooltip';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, TooltipModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Tooltip component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Tooltip Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/tooltip/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React, { useRef } from "react";
import { Button } from 'smart-webcomponents-react/button';
import { RadioButton } from 'smart-webcomponents-react/radiobutton';
import { Tooltip } from 'smart-webcomponents-react/tooltip';

const App = () => {
  const tooltip = useRef(null);

  const handleChange = (position) => {
    if (tooltip.current) {
      tooltip.current.position = position;
    }
  };

  return (
    <div>
      <Button id="button">Button</Button>
      <Tooltip ref={tooltip} id="tooltip" selector="button" arrow>
        This is a tooltip for smartButton
      </Tooltip>
      <div className="options">
        <h3>Tooltip Position:</h3>
        <RadioButton enableContainerClick checked onChange={() => handleChange('top')}>
          Top
        </RadioButton>
        <br />
        <RadioButton enableContainerClick onChange={() => handleChange('bottom')}>
          Bottom
        </RadioButton>
        <br />
        <RadioButton enableContainerClick onChange={() => handleChange('left')}>
          Left
        </RadioButton>
        <br />
        <RadioButton enableContainerClick onChange={() => handleChange('right')}>
          Right
        </RadioButton>
        <br />
      </div>
    </div>
  );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Tooltip, TooltipProps } from 'smart-webcomponents-react/tooltip';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Tooltip component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.